#define BLOCK_SIZE 8
#define NUM_CLASS -1
#define NUM_GROUP 16
#define PRD_ORDER -1
#define COEF_PRECISION 6
#define MAX_UPARA 512
#define NUM_UPELS 6
#define UPEL_DIST 2
#define MAX_ITERATION 100
#define EXTRA_ITERATION 10
#define VLC_MAXLEN 32
#define MAGIC_NUMBER ('M' << 8) + 'R'
#define BANNER "encmrp/decmrp version %.1f (Feb. 2002)"
#define VERSION 2
#define uchar unsigned char
#define img_t unsigned short

typedef struct {
    int height;
    int width;
    int maxval;
    img_t **val;
} IMAGE;

typedef struct {
    int size;
    int max_len;
    int *len;
    int *index;
    int *off;
    unsigned int *code;
} VLC;

typedef struct {
    int y, x;
} POINT;

typedef struct {
    int height;
    int width;
    int maxval;
    int num_class;
    int num_group;
    int prd_order;
    int coef_precision;
    int **predictor;
    int **th;
    int **cost;
    int **upara;
    img_t ***ref_pels;
    img_t **abs_e;
    img_t **idx_E;
    img_t **cost_e;
    img_t **econv;
    uchar **class;
    uchar **group;
    VLC **vlc;
} ENCODER;

typedef struct {
    int version;
    int height;
    int width;
    int maxval;
    int num_comp;
    int num_class;
    int num_group;
    int prd_order;
    int coef_precision;
    int **predictor;
    int **th;
    img_t **idx_E;
    uchar **class;
    VLC **vlc;
} DECODER;

/* common.c */
FILE *fileopen(char *, char *);
void **alloc_2d_array(int, int, int);
IMAGE *alloc_image(int, int, int);
int *gen_hufflen(int *, int, int);
void gen_huffcode(VLC *);
VLC *make_vlc(int *, int, int);
VLC **init_vlc(int, int);
void free_vlc(VLC *);
int calc_u(img_t **, int, int, int);
int e2E(int, int, int, int);
int E2e(int, int, int, int);
